unit api_func;

interface

uses Windows, Messages, OpenGl, Gl, Glu;

function WinMain(hInstance: HINST; hPrevInstance: HINST; lpCmdLine: PChar; nCmdShow: integer): integer; stdcall;

var
  keys: array[0..255] of BOOL; // tablicy klawiatury
  h_RC: HGLRC;
  h_DC: HDC; //uchwyt programu

implementation

uses Render, Timer;

//Inicjacja OpenGl

procedure GLInit(AWidth: GLsizei; AHeight: GLsizei);
begin

  SetVertex;

  glEnable(GL_TEXTURE_2D); // Mapowanie tekstur 2D
  glClearColor(0, 0, 0, 0); // Kolor tla
  glClearDepth(1.0); // Czyszczenie bufora
  glEnable(GL_DEPTH_TEST); // Wcz testowanie gbokoci
  glDepthFunc(GL_LEQUAL); // Rodzaj testowania gbokoci : GL_LESS

  gluPerspective(45.0, AWidth / AHeight, 0.1, 500.0); // Ustawianie perspektywy
  glMatrixMode(GL_MODELVIEW);  // ustawienie widoku modelu
  glLoadIdentity(); // Reset macierzy
end;

// Zmiana rozmiaru okna

procedure GLResizeScene(AWidth: GLsizei; AHeight: GLsizei);
begin
  if (AHeight = 0) then // ochrona przed bldem wysokosci
    AHeight := 1;

  glViewport(0, 0, AWidth, AHeight); // Reset okna

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  gluPerspective(45.0, AWidth / AHeight, 0.1, 500.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
end;


function WndProc(hWnd: HWND;
  message: UINT;
  wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall;

var
  Screen: TRECT;
  PixelFormat: GLuint;

const
  pfd: PIXELFORMATDESCRIPTOR = (
    nSize: sizeof(PIXELFORMATDESCRIPTOR);
    nVersion: 1;
    dwFlags: PFD_DRAW_TO_WINDOW
    or PFD_SUPPORT_OPENGL
    or PFD_DOUBLEBUFFER;
    iPixelType: PFD_TYPE_RGBA;
    cColorBits: 32;
    cRedBits: 0;
    cRedShift: 0;
    cGreenBits: 0;
    cBlueBits: 0;
    cBlueShift: 0;
    cAlphaBits: 0;
    cAlphaShift: 0;
    cAccumBits: 0;
    cAccumRedBits: 0;
    cAccumGreenBits: 0;
    cAccumBlueBits: 0;
    cAccumAlphaBits: 0;
    cDepthBits: 32;
    cStencilBits: 0;
    cAuxBuffers: 0;
    iLayerType: PFD_MAIN_PLANE;
    bReserved: 0;
    dwLayerMask: 0;
    dwVisibleMask: 0;
    dwDamageMask: 0);

begin
  Result := 0;
  case (message) of // Obsluga komunikatw
    WM_CREATE:
      begin
        h_DC := GetDC(hWnd);
        PixelFormat := ChoosePixelFormat(h_DC, @pfd);

        if (PixelFormat = 0) then
        begin
          MessageBox(0, 'Cant''t Find A Suitable PixelFormat.', 'Error', MB_OK or MB_ICONERROR);
          PostQuitMessage(0); // komunikat zamyka program
          exit;
        end;

        if (not SetPixelFormat(h_DC, PixelFormat, @pfd)) then
        begin
          MessageBox(0, 'Can''t Set The PixelFormat.', 'Error', MB_OK or MB_ICONERROR);
          PostQuitMessage(0);
          exit;
        end;

        h_RC := wglCreateContext(h_DC);
        if (h_RC = 0) then
        begin
          MessageBox(0, 'Can''t Create A GL Rendering Context.', 'Error', MB_OK or MB_ICONERROR);
          PostQuitMessage(0);
          exit;
        end;

        if (not wglMakeCurrent(h_DC, h_RC)) then
        begin
          MessageBox(0, 'Can''t activate GLRC.', 'Error', MB_OK or MB_ICONERROR);
          PostQuitMessage(0);
          exit;
        end;

        GetClientRect(hWnd, Screen);
        GLInit(Screen.right, Screen.bottom);
      end;
    WM_DESTROY, WM_CLOSE:
      begin
        ChangeDisplaySettings(DEVMODE(nil^), 0);

        wglMakeCurrent(h_DC, 0);
        wglDeleteContext(h_RC);
        ReleaseDC(hWnd, h_DC);

        PostQuitMessage(0);
      end;
    WM_KEYDOWN:
      begin
        keys[wParam] := TRUE;
      end;
    WM_KEYUP:
      begin
        keys[wParam] := FALSE;
      end;
    WM_SIZE:
      begin
        GLReSizeScene(LOWORD(lParam), HIWORD(lParam));
      end;
  else
    begin
      Result := DefWindowProc(hWnd, message, wParam, lParam);
      exit;
    end;
  end;
end;

function WinMain(hInstance: HINST; hPrevInstance: HINST; lpCmdLine: PChar; nCmdShow: integer): integer; stdcall;
var
  msg: TMsg; // Komunikat
  wc: TWndClass; // Klasa okna
  h_Wnd: HWND; // Uchwyt
  dmScreenSettings: DEVMODE;
  kom1: shortstring;
  kom2: pchar;

begin
  ZeroMemory(@wc, sizeof(wc));

  wc.style := CS_HREDRAW or CS_VREDRAW or CS_OWNDC;
  wc.lpfnWndProc := @WndProc;
  wc.hInstance := hInstance;
  wc.hCursor := LoadCursor(0, IDC_ARROW);
  wc.lpszClassName := 'OpenGL WinClass';

  if (RegisterClass(wc) = 0) then
  begin
    MessageBox(0, 'Wystpil bld podczas prby rejestracji klasy okna', 'Error', MB_OK or MB_ICONERROR);
    Result := 0;
    exit;
  end;

  h_Wnd := CreateWindow(
    'OpenGL WinClass',
    'basecode', // Tytul programu
    WS_POPUP or
    WS_CLIPCHILDREN or
    WS_CLIPSIBLINGS,
    0, 0, // Pozycja okna na ekranie
    800, 600, // Szerokosc i wysokosc okna
    0,
    0,
    hInstance,
    nil);

  if (h_Wnd = 0) then
  begin
    MessageBox(0, 'Wystpil bld podczas prby tworzenia okna', 'Error', MB_OK or MB_ICONERROR);
    Result := 0;
    exit;
  end;

  ZeroMemory(@dmScreenSettings, sizeof(DEVMODE));
  dmScreenSettings.dmSize := sizeof(DEVMODE);
  dmScreenSettings.dmPelsWidth := 800; // Szerokosc
  dmScreenSettings.dmPelsHeight := 600; // Wysokosc
  dmScreenSettings.dmFields := DM_PELSWIDTH or DM_PELSHEIGHT; // Color Depth
  ChangeDisplaySettings(dmScreenSettings, CDS_FULLSCREEN); // Przelcz na pelny ekran

  ShowWindow(h_Wnd, SW_SHOW);
  UpdateWindow(h_Wnd);
  SetFocus(h_Wnd);

  while (true) do
  begin
    while (PeekMessage(msg, 0, 0, 0, PM_NOREMOVE)) do
    begin
      if (GetMessage(msg, 0, 0, 0)) then
      begin
        TranslateMessage(msg);
        DispatchMessage(msg);
      end
      else
      begin
        Result := 1;
        exit;
      end;
    end;

    RenderScene;

    if (keys[VK_ESCAPE]) then begin;
      SendMessage(h_Wnd, WM_CLOSE, 0, 0);
    end;

  end;

end;

end.

