unit render;

interface

uses Windows, OpenGl, Gl, Glu, Api_Func, Timer;

procedure RenderScene;
procedure RenderFrame;
procedure Fog;

var t: real;
    i: integer;

implementation

procedure RenderScene;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT); // czyszczenie buforow koloru i glebokosci
  glLoadIdentity();
  FrameMath;
  RenderFrame;
  SwapBuffers(h_DC);
end;

procedure Fog;
var r, g, b: glfloat; // Zmienne decydujce o kolorze mgly
begin
  glEnable(GL_FOG); //Wczamy obslug mgy
  glFogi(GL_FOG_MODE, GL_LINEAR); // Wybieramy rodzaj mgly
  r := 0.5; // Nasycenie koloru czerwonego
  g := 0.5; // Nasycenie koloru zielonego
  b := 0.5; // Nasycenie koloru czerwonego
  glFogfv(GL_FOG_COLOR, @b); // Przypisanie barwy niebieskiej
  glFogfv(GL_FOG_COLOR, @g); // Przypisanie barwy zielonej
  glFogfv(GL_FOG_COLOR, @r); // Przypisanie barwy czerwonej
  glFogf(GL_FOG_DENSITY, 0.5); // Gstosc  mgly
  glFogf(GL_FOG_START, 0.0); // Zakres mgy - pocztek
  glFogf(GL_FOG_end, 50 - t); // Zakres mgy - koniec
end;

procedure RenderFrame;
begin
  //Mgla
  Fog;

  //Obrt
  glTranslatef(0.0, 0.0, -12.0);

  //prymityw
  glbegin(GL_TRIANGLES);
    glColor3f(1.0, 0.0, 0.0);
    glVertex3f(-5, -3, 2);

    glColor3f(0.0, 1.0, 0.0);
    glVertex3f(5, -3, 2);

    glColor3f(0.0, 0.0, 1.0);
    glVertex3f(0, 3, -20);
  glEnd();

  glColor(1.0,1.0,1.0);

  // tablica wierzcholkw
  glDrawElements(GL_TRIANGLES, 3, GL_UNSIGNED_INT, @Indices);
end;


end.


